var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
import * as setCustomFormatter from './setCustomFormatter';
import * as _ from 'lodash';
import * as EventUtils from '../utils/EventUtils';
function setRotatePolarAxis(chart, axisItem, coord, data) {
    var polarLabel = _.get(axisItem, 'polarLabel');
    var rotate = _.get(axisItem, 'polarLabel.rotate');
    if (!rotate) {
        return;
    }
    var tickStyle = {};
    if (rotate === 'parallel') {
        tickStyle = {
            rotate: coord.startAngle,
            textAlign: 'center'
        };
    }
    else if (rotate === 'normal') {
        tickStyle = {
            rotate: coord.startAngle + 90,
            textAlign: 'right'
        };
    }
    var offsetX = _.get(axisItem, 'polarLabel.offsetX');
    var offsetY = _.get(axisItem, 'polarLabel.offsetY');
    data.forEach(function (res, i) {
        chart.guide().text(__assign({ position: [i, 0], content: data[i][axisItem.dataKey], style: __assign({ polarLabel: polarLabel }, tickStyle) }, offsetX, offsetY));
    });
}
export var process = function (chart, config) {
    if (!config.axis || (_.isArray(config.axis) && config.axis.length === 0)) {
        return chart.axis(false);
    }
    var axis = config.axis = Array.isArray(config.axis) ? config.axis : [config.axis];
    var coord = config.coord, data = config.data;
    if (axis === true) {
        return chart.axis();
    }
    for (var _i = 0, axis_1 = axis; _i < axis_1.length; _i++) {
        var res = axis_1[_i];
        if (res.show === false) {
            return chart.axis(res.dataKey, false);
        }
        if (coord && coord.type === 'polar' && coord.direction === 'rotate') {
            setRotatePolarAxis(chart, res, coord, data);
        }
        if (res.label) {
            res.label = setCustomFormatter.supportD3Formatter(res.label);
        }
        var options = _.omit(res, ['show', 'dataKey']);
        chart.axis(res.dataKey, options);
        for (var item in res) {
            if (res.hasOwnProperty(item)) {
                var name_1 = "axis-" + item;
                if (item === 'tickLine') {
                    name_1 = 'axis-ticks';
                }
                EventUtils.setEvent(chart, name_1, res[item]);
            }
        }
    }
    return chart;
};
//# sourceMappingURL=setAxisConfig.js.map