'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.process = undefined;

var _omit2 = require('lodash/omit');

var _omit3 = _interopRequireDefault(_omit2);

var _EventUtils = require('../utils/EventUtils');

var EventUtils = _interopRequireWildcard(_EventUtils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var regEventName = /on(.+)(MouseEnter|MouseMove|MouseLeave|Click|DdlClick|MouseDown|MouseUp|TouchStart|TouchMove|TouchEnd)/;
function setHighlight(item) {
    item.onHover = function (ev) {
        var shapes = ev.shapes;
        var geom = ev.geom;
        geom.highlightShapes(shapes);
    };
    return item;
}
var process = exports.process = function process(chart, config) {
    var legend = config.legend;
    var isArr = Array.isArray(legend);
    if (!legend || isArr && legend.length === 0) {
        return chart.legend(false);
    }
    var arrLegend = isArr ? legend : [legend];
    for (var _i = 0, arrLegend_1 = arrLegend; _i < arrLegend_1.length; _i++) {
        var res = arrLegend_1[_i];
        if (res.highlight) {
            res = setHighlight(res);
        }
        for (var item in res) {
            if (res.hasOwnProperty(item)) {
                EventUtils.setSEvent(chart, 'legend', item, res[item]);
            }
        }
        if (res.dataKey) {
            if (res.show === false) {
                return chart.legend(res.dataKey, false);
            }
            var option = (0, _omit3.default)(res, ['dataKey', 'show']);
            return chart.legend(res.dataKey, option);
        } else {
            return chart.legend(res);
        }
    }
};
//# sourceMappingURL=setLengendConfig.js.map